
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>NetNS module &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="WireGuard module" href="wireguard.html" />
    <link rel="prev" title="IPSet module" href="ipset.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="wireguard.html" title="WireGuard module"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ipset.html" title="IPSet module"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-pyroute2.netns">
<span id="netns-module"></span><span id="netns"></span><h1>NetNS module<a class="headerlink" href="#module-pyroute2.netns" title="Permalink to this headline">¶</a></h1>
<div class="section" id="netns-management-overview">
<h2>Netns management overview<a class="headerlink" href="#netns-management-overview" title="Permalink to this headline">¶</a></h2>
<p>Pyroute2 provides basic namespaces management support.
Here’s a quick overview of typical netns tasks and
related pyroute2 tools.</p>
<div class="section" id="move-an-interface-to-a-namespace">
<h3>Move an interface to a namespace<a class="headerlink" href="#move-an-interface-to-a-namespace" title="Permalink to this headline">¶</a></h3>
<p>Though this task is managed not via <cite>netns</cite> module, it
should be mentioned here as well. To move an interface
to a netns, one should provide IFLA_NET_NS_FD nla in
a set link RTNL request. The nla is an open FD number,
that refers to already created netns. The pyroute2
library provides also a possibility to specify not a
FD number, but a netns name as a string. In that case
the library will try to lookup the corresponding netns
in the standard location.</p>
<p>Create veth and move the peer to a netns with IPRoute:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">IPRoute</span>
<span class="n">ipr</span> <span class="o">=</span> <span class="n">IPRoute</span><span class="p">()</span>
<span class="n">ipr</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;add&#39;</span><span class="p">,</span> <span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;veth&#39;</span><span class="p">,</span> <span class="n">peer</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)</span>
<span class="n">idx</span> <span class="o">=</span> <span class="n">ipr</span><span class="o">.</span><span class="n">link_lookup</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">ipr</span><span class="o">.</span><span class="n">link</span><span class="p">(</span><span class="s1">&#39;set&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="n">idx</span><span class="p">,</span> <span class="n">net_ns_fd</span><span class="o">=</span><span class="s1">&#39;netns_name&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>Create veth and move the peer to a netns with IPDB:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">IPDB</span>
<span class="n">ipdb</span> <span class="o">=</span> <span class="n">IPDB</span><span class="p">()</span>
<span class="n">ipdb</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;veth&#39;</span><span class="p">,</span> <span class="n">peer</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
<span class="k">with</span> <span class="n">ipdb</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">v0p1</span> <span class="k">as</span> <span class="n">i</span><span class="p">:</span>
    <span class="n">i</span><span class="o">.</span><span class="n">net_ns_fd</span> <span class="o">=</span> <span class="s1">&#39;netns_name&#39;</span>
</pre></div>
</div>
</div>
<div class="section" id="manage-interfaces-within-a-netns">
<h3>Manage interfaces within a netns<a class="headerlink" href="#manage-interfaces-within-a-netns" title="Permalink to this headline">¶</a></h3>
<p>This task can be done with <cite>NetNS</cite> objects. A <cite>NetNS</cite> object
spawns a child and runs it within a netns, providing the same
API as <cite>IPRoute</cite> does:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;netns_name&#39;</span><span class="p">)</span>
<span class="c1"># do some stuff within the netns</span>
<span class="n">ns</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
</pre></div>
</div>
<p>One can even start <cite>IPDB</cite> on the top of <cite>NetNS</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">IPDB</span>
<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;netns_name&#39;</span><span class="p">)</span>
<span class="n">ipdb</span> <span class="o">=</span> <span class="n">IPDB</span><span class="p">(</span><span class="n">nl</span><span class="o">=</span><span class="n">ns</span><span class="p">)</span>
<span class="c1"># do some stuff within the netns</span>
<span class="n">ipdb</span><span class="o">.</span><span class="n">release</span><span class="p">()</span>
<span class="n">ns</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="section" id="spawn-a-process-within-a-netns">
<h3>Spawn a process within a netns<a class="headerlink" href="#spawn-a-process-within-a-netns" title="Permalink to this headline">¶</a></h3>
<p>For that purpose one can use <cite>NSPopen</cite> API. It works just
as normal <cite>Popen</cite>, but starts a process within a netns.</p>
</div>
<div class="section" id="list-set-create-attach-and-remove-netns">
<h3>List, set, create, attach and remove netns<a class="headerlink" href="#list-set-create-attach-and-remove-netns" title="Permalink to this headline">¶</a></h3>
<p>These functions are described below. To use them, import
<cite>netns</cite> module:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">netns</span>
<span class="n">netns</span><span class="o">.</span><span class="n">listnetns</span><span class="p">()</span>
</pre></div>
</div>
<p>Please be aware, that in order to run system calls the
library uses <cite>ctypes</cite> module. It can fail on platforms
where SELinux is enforced. If the Python interpreter,
loading this module, dumps the core, one can check the
SELinux state with <cite>getenforce</cite> command.</p>
<dl class="function">
<dt id="pyroute2.netns.listnetns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">listnetns</code><span class="sig-paren">(</span><em class="sig-param">nspath=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.listnetns" title="Permalink to this definition">¶</a></dt>
<dd><p>List available network namespaces.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.ns_pids">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">ns_pids</code><span class="sig-paren">(</span><em class="sig-param">nspath='/var/run/netns'</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.ns_pids" title="Permalink to this definition">¶</a></dt>
<dd><p>List pids in all netns</p>
<p>If a pid is in a unknown netns do not return it</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.pid_to_ns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">pid_to_ns</code><span class="sig-paren">(</span><em class="sig-param">pid=1</em>, <em class="sig-param">nspath='/var/run/netns'</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.pid_to_ns" title="Permalink to this definition">¶</a></dt>
<dd><p>Return netns name which matches the given pid,
None otherwise</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.create">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">create</code><span class="sig-paren">(</span><em class="sig-param">netns</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.create" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a network namespace.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.attach">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">attach</code><span class="sig-paren">(</span><em class="sig-param">netns</em>, <em class="sig-param">pid</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.attach" title="Permalink to this definition">¶</a></dt>
<dd><p>Attach the network namespace of the process <cite>pid</cite>
to <cite>netns</cite> as if it were created with <cite>create</cite>.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.remove">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">remove</code><span class="sig-paren">(</span><em class="sig-param">netns</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.remove" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove a network namespace.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.setns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">setns</code><span class="sig-paren">(</span><em class="sig-param">netns</em>, <em class="sig-param">flags=64</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.setns" title="Permalink to this definition">¶</a></dt>
<dd><p>Set netns for the current process.</p>
<p>The flags semantics is the same as for the <cite>open(2)</cite>
call:</p>
<blockquote>
<div><ul class="simple">
<li><p>O_CREAT – create netns, if doesn’t exist</p></li>
<li><p>O_CREAT | O_EXCL – create only if doesn’t exist</p></li>
</ul>
</div></blockquote>
<p>Note that “main” netns has no name. But you can access it with:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">setns</span><span class="p">(</span><span class="s1">&#39;foo&#39;</span><span class="p">)</span>  <span class="c1"># move to netns foo</span>
<span class="n">setns</span><span class="p">(</span><span class="s1">&#39;/proc/1/ns/net&#39;</span><span class="p">)</span>  <span class="c1"># go back to default netns</span>
</pre></div>
</div>
<p>See also <cite>pushns()</cite>/<cite>popns()</cite>/<cite>dropns()</cite></p>
<p>Changed in 0.5.1: the routine closes the ns fd if it’s
not provided via arguments.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.pushns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">pushns</code><span class="sig-paren">(</span><em class="sig-param">newns=None</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.pushns" title="Permalink to this definition">¶</a></dt>
<dd><p>Save the current netns in order to return to it later. If newns is
specified, change to it:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># --&gt; the script in the &quot;main&quot; netns</span>
<span class="n">netns</span><span class="o">.</span><span class="n">pushns</span><span class="p">(</span><span class="s2">&quot;test&quot;</span><span class="p">)</span>
<span class="c1"># --&gt; changed to &quot;test&quot;, the &quot;main&quot; is saved</span>
<span class="n">netns</span><span class="o">.</span><span class="n">popns</span><span class="p">()</span>
<span class="c1"># --&gt; &quot;test&quot; is dropped, back to the &quot;main&quot;</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.popns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">popns</code><span class="sig-paren">(</span><em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.popns" title="Permalink to this definition">¶</a></dt>
<dd><p>Restore the previously saved netns.</p>
</dd></dl>

<dl class="function">
<dt id="pyroute2.netns.dropns">
<code class="sig-prename descclassname">pyroute2.netns.</code><code class="sig-name descname">dropns</code><span class="sig-paren">(</span><em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.dropns" title="Permalink to this definition">¶</a></dt>
<dd><p>Discard the last saved with <cite>pushns()</cite> namespace</p>
</dd></dl>

</div>
</div>
<span class="target" id="module-pyroute2.netns.nslink"></span><div class="section" id="netns-objects">
<h2>NetNS objects<a class="headerlink" href="#netns-objects" title="Permalink to this headline">¶</a></h2>
<p>A NetNS object is IPRoute-like. It runs in the main network
namespace, but also creates a proxy process running in
the required netns. All the netlink requests are done via
that proxy process.</p>
<p>NetNS supports standard IPRoute API, so can be used instead
of IPRoute, e.g., in IPDB:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># start the main network settings database:</span>
<span class="n">ipdb_main</span> <span class="o">=</span> <span class="n">IPDB</span><span class="p">()</span>
<span class="c1"># start the same for a netns:</span>
<span class="n">ipdb_test</span> <span class="o">=</span> <span class="n">IPDB</span><span class="p">(</span><span class="n">nl</span><span class="o">=</span><span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">))</span>

<span class="c1"># create VETH</span>
<span class="n">ipdb_main</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;v0p0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;veth&#39;</span><span class="p">,</span> <span class="n">peer</span><span class="o">=</span><span class="s1">&#39;v0p1&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>

<span class="c1"># move peer VETH into the netns</span>
<span class="k">with</span> <span class="n">ipdb_main</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">v0p1</span> <span class="k">as</span> <span class="n">veth</span><span class="p">:</span>
    <span class="n">veth</span><span class="o">.</span><span class="n">net_ns_fd</span> <span class="o">=</span> <span class="s1">&#39;test&#39;</span>

<span class="c1"># please keep in mind, that netns move clears all the settings</span>
<span class="c1"># on a VETH interface pair, so one should run netns assignment</span>
<span class="c1"># as a separate operation only</span>

<span class="c1"># assign addresses</span>
<span class="c1"># please notice, that `v0p1` is already in the `test` netns,</span>
<span class="c1"># so should be accessed via `ipdb_test`</span>
<span class="k">with</span> <span class="n">ipdb_main</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">v0p0</span> <span class="k">as</span> <span class="n">veth</span><span class="p">:</span>
    <span class="n">veth</span><span class="o">.</span><span class="n">add_ip</span><span class="p">(</span><span class="s1">&#39;172.16.200.1/24&#39;</span><span class="p">)</span>
    <span class="n">veth</span><span class="o">.</span><span class="n">up</span><span class="p">()</span>
<span class="k">with</span> <span class="n">ipdb_test</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">v0p1</span> <span class="k">as</span> <span class="n">veth</span><span class="p">:</span>
    <span class="n">veth</span><span class="o">.</span><span class="n">add_ip</span><span class="p">(</span><span class="s1">&#39;172.16.200.2/24&#39;</span><span class="p">)</span>
    <span class="n">veth</span><span class="o">.</span><span class="n">up</span><span class="p">()</span>
</pre></div>
</div>
<p>Please review also the test code, under <cite>tests/test_netns.py</cite> for
more examples.</p>
<p>By default, NetNS creates requested netns, if it doesn’t exist,
or uses existing one. To control this behaviour, one can use flags
as for <cite>open(2)</cite> system call:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># create a new netns or fail, if it already exists</span>
<span class="n">netns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">,</span> <span class="n">flags</span><span class="o">=</span><span class="n">os</span><span class="o">.</span><span class="n">O_CREAT</span> <span class="o">|</span> <span class="n">os</span><span class="o">.</span><span class="n">O_EXCL</span><span class="p">)</span>

<span class="c1"># create a new netns or use existing one</span>
<span class="n">netns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">,</span> <span class="n">flags</span><span class="o">=</span><span class="n">os</span><span class="o">.</span><span class="n">O_CREAT</span><span class="p">)</span>

<span class="c1"># the same as above, the default behaviour</span>
<span class="n">netns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>To remove a network namespace:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="n">netns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
<span class="n">netns</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
<span class="n">netns</span><span class="o">.</span><span class="n">remove</span><span class="p">()</span>
</pre></div>
</div>
<p>One should stop it first with <cite>close()</cite>, and only after that
run <cite>remove()</cite>.</p>
<dl class="class">
<dt id="pyroute2.netns.nslink.NetNS">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.netns.nslink.</code><code class="sig-name descname">NetNS</code><span class="sig-paren">(</span><em class="sig-param">netns</em>, <em class="sig-param">flags=64</em>, <em class="sig-param">target=None</em>, <em class="sig-param">libc=None</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.nslink.NetNS" title="Permalink to this definition">¶</a></dt>
<dd><p>NetNS is the IPRoute API with network namespace support.</p>
<p><strong>Why not IPRoute?</strong></p>
<p>The task to run netlink commands in some network namespace, being in
another network namespace, requires the architecture, that differs
too much from a simple Netlink socket.</p>
<p>NetNS starts a proxy process in a network namespace and uses
<cite>multiprocessing</cite> communication channels between the main and the proxy
processes to route all <cite>recv()</cite> and <cite>sendto()</cite> requests/responses.</p>
<p><strong>Any specific API calls?</strong></p>
<p>Nope. <cite>NetNS</cite> supports all the same, that <cite>IPRoute</cite> does, in the same
way. It provides full <cite>socket</cite>-compatible API and can be used in
poll/select as well.</p>
<p>The only difference is the <cite>close()</cite> call. In the case of <cite>NetNS</cite> it
is <strong>mandatory</strong> to close the socket before exit.</p>
<dl class="method">
<dt id="pyroute2.netns.nslink.NetNS.remove">
<code class="sig-name descname">remove</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.nslink.NetNS.remove" title="Permalink to this definition">¶</a></dt>
<dd><p>Try to remove this network namespace from the system.</p>
</dd></dl>

</dd></dl>

</div>
<span class="target" id="module-pyroute2.netns.process.proxy"></span><div class="section" id="nspopen">
<h2>NSPopen<a class="headerlink" href="#nspopen" title="Permalink to this headline">¶</a></h2>
<p>The <cite>NSPopen</cite> class has nothing to do with netlink at
all, but it is required to have a reasonable network
namespace support.</p>
<dl class="class">
<dt id="pyroute2.netns.process.proxy.NSPopen">
<em class="property">class </em><code class="sig-prename descclassname">pyroute2.netns.process.proxy.</code><code class="sig-name descname">NSPopen</code><span class="sig-paren">(</span><em class="sig-param">nsname</em>, <em class="sig-param">*argv</em>, <em class="sig-param">**kwarg</em><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.process.proxy.NSPopen" title="Permalink to this definition">¶</a></dt>
<dd><p>A proxy class to run <cite>Popen()</cite> object in some network namespace.</p>
<p>Sample to run <cite>ip ad</cite> command in <cite>nsname</cite> network namespace:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">nsp</span> <span class="o">=</span> <span class="n">NSPopen</span><span class="p">(</span><span class="s1">&#39;nsname&#39;</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;ip&#39;</span><span class="p">,</span> <span class="s1">&#39;ad&#39;</span><span class="p">],</span> <span class="n">stdout</span><span class="o">=</span><span class="n">subprocess</span><span class="o">.</span><span class="n">PIPE</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">nsp</span><span class="o">.</span><span class="n">communicate</span><span class="p">())</span>
<span class="n">nsp</span><span class="o">.</span><span class="n">wait</span><span class="p">()</span>
<span class="n">nsp</span><span class="o">.</span><span class="n">release</span><span class="p">()</span>
</pre></div>
</div>
<p>The <cite>NSPopen</cite> class was intended to be a drop-in replacement
for the <cite>Popen</cite> class, but there are still some important
differences.</p>
<p>The <cite>NSPopen</cite> object implicitly spawns a child python process
to be run in the background in a network namespace. The target
process specified as the argument of the <cite>NSPopen</cite> will be
started in its turn from this child. Thus all the fd numbers
of the running <cite>NSPopen</cite> object are meaningless in the context
of the main process. Trying to operate on them, one will get
‘Bad file descriptor’ in the best case or a system call working
on a wrong file descriptor in the worst case. A possible
solution would be to transfer file descriptors between the
<cite>NSPopen</cite> object and the main process, but it is not implemented
yet.</p>
<p>The process’ diagram for <cite>NSPopen(‘test’, [‘ip’, ‘ad’])</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>+---------------------+     +--------------+     +------------+
| main python process |&lt;---&gt;| child python |&lt;---&gt;| netns test |
| NSPopen()           |     | Popen()      |     | $ ip ad    |
+---------------------+     +--------------+     +------------+
</pre></div>
</div>
<p>As a workaround for the issue with file descriptors, some
additional methods are available on file objects <cite>stdin</cite>,
<cite>stdout</cite> and <cite>stderr</cite>. E.g., one can run fcntl calls:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">fcntl</span> <span class="k">import</span> <span class="n">F_GETFL</span>
<span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NSPopen</span>
<span class="kn">from</span> <span class="nn">subprocess</span> <span class="k">import</span> <span class="n">PIPE</span>

<span class="n">proc</span> <span class="o">=</span> <span class="n">NSPopen</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;my_program&#39;</span><span class="p">],</span> <span class="n">stdout</span><span class="o">=</span><span class="n">PIPE</span><span class="p">)</span>
<span class="n">flags</span> <span class="o">=</span> <span class="n">proc</span><span class="o">.</span><span class="n">stdout</span><span class="o">.</span><span class="n">fcntl</span><span class="p">(</span><span class="n">F_GETFL</span><span class="p">)</span>
</pre></div>
</div>
<p>In that way one can use <cite>fcntl()</cite>, <cite>ioctl()</cite>, <cite>flock()</cite> and
<cite>lockf()</cite> calls.</p>
<p>Another additional method is <cite>release()</cite>, which can be used to
explicitly stop the proxy process and release all the resources.</p>
<dl class="method">
<dt id="pyroute2.netns.process.proxy.NSPopen.release">
<code class="sig-name descname">release</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyroute2.netns.process.proxy.NSPopen.release" title="Permalink to this definition">¶</a></dt>
<dd><p>Explicitly stop the proxy process and release all the
resources. The <cite>NSPopen</cite> object can not be used after
the <cite>release()</cite> call.</p>
</dd></dl>

</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">NetNS module</a><ul>
<li><a class="reference internal" href="#netns-management-overview">Netns management overview</a><ul>
<li><a class="reference internal" href="#move-an-interface-to-a-namespace">Move an interface to a namespace</a></li>
<li><a class="reference internal" href="#manage-interfaces-within-a-netns">Manage interfaces within a netns</a></li>
<li><a class="reference internal" href="#spawn-a-process-within-a-netns">Spawn a process within a netns</a></li>
<li><a class="reference internal" href="#list-set-create-attach-and-remove-netns">List, set, create, attach and remove netns</a></li>
</ul>
</li>
<li><a class="reference internal" href="#netns-objects">NetNS objects</a></li>
<li><a class="reference internal" href="#nspopen">NSPopen</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ipset.html"
                        title="previous chapter">IPSet module</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="wireguard.html"
                        title="next chapter">WireGuard module</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/netns.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="wireguard.html" title="WireGuard module"
             >next</a> |</li>
        <li class="right" >
          <a href="ipset.html" title="IPSet module"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>